Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members

# TAO_SSLIOP_Credentials Class Reference

SSLIOP-specific implementation of the SecurityLevel2::Credentials interface. More...

`#include <SSLIOP_Credentials.h>`

Inheritance diagram for TAO_SSLIOP_Credentials:

[legend]
Collaboration diagram for TAO_SSLIOP_Credentials:

[legend]
List of all members.

## [NOHEADER]
typedef TAO_SSLIOP_Credentials_ptr | _ptr_type
typedef TAO_SSLIOP_Credentials_var | _var_type
TAO_SSLIOP_Credentials_ptr | _duplicate (TAO_SSLIOP_Credentials_ptr obj)
TAO_SSLIOP_Credentials_ptr | _narrow (CORBA::Object_ptr obj ACE_ENV_ARG_DECL_WITH_DEFAULTS)
TAO_SSLIOP_Credentials_ptr | _nil (void)
int | _tao_class_id = 0
## Public Methods
| TAO_SSLIOP_Credentials (X509 *cert, EVP_PKEY *evp)
| Constructor.
virtual SecurityLevel2::Credentials_ptr | copy (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual void | destroy (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual Security::InvocationCredentialsType | credentials_type (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
| Return the invocation credentials type this object is.
virtual Security::AuthenticationStatus | authentication_state (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual char * | mechanism (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual Security::AssociationOptions | accepting_options_supported (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual void | accepting_options_supported (Security::AssociationOptions accepting_options_supported ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual Security::AssociationOptions | accepting_options_required (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual void | accepting_options_required (Security::AssociationOptions accepting_options_required ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual Security::AssociationOptions | invocation_options_supported (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual void | invocation_options_supported (Security::AssociationOptions invocation_options_supported ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual Security::AssociationOptions | invocation_options_required (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual void | invocation_options_required (Security::AssociationOptions invocation_options_required ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual CORBA::Boolean | get_security_feature (Security::CommunicationDirection direction, Security::SecurityFeature feature ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual CORBA::Boolean | set_attributes (const Security::AttributeList &requested_attributes, Security::AttributeList_out actual_attributes ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual Security::AttributeList * | get_attributes (const Security::AttributeTypeList &attributes ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual CORBA::Boolean | is_valid (Security::UtcT_out expiry_time ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
| Verify that this credential is still valid.
virtual CORBA::Boolean | refresh (const CORBA::Any &refresh_data ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
EVP_PKEY * | evp (void)
| Return a pointer to the underlying private key.
CORBA::Boolean | operator== (const TAO_SSLIOP_Credentials &rhs)
CORBA::ULong | hash (void) const
More TAO_Connector methods
X509 * | x509 (void)
| Return a pointer to the underlying X.509 certificate.
## Protected Methods
| ~TAO_SSLIOP_Credentials (void)
| Destructor.
## Protected Attributes
Security::AssociationOptions | accepting_options_supported_
Security::AssociationOptions | accepting_options_required_
Security::AssociationOptions | invocation_options_supported_
Security::AssociationOptions | invocation_options_required_
TAO_SSLIOP_X509_var | x509_
TAO_SSLIOP_EVP_PKEY_var | evp_

## Detailed Description

SSLIOP-specific implementation of the SecurityLevel2::Credentials interface.

This class encapsulates the X.509 certificate associated with a given a principal.

## Member Typedef Documentation

typedef TAO_SSLIOP_Credentials_ptr TAO_SSLIOP_Credentials::_ptr_type

| Reimplemented from CORBA::LocalObject. Reimplemented in TAO_SSLIOP_ReceivedCredentials, and TAO_SSLIOP_TargetCredentials.

typedef TAO_SSLIOP_Credentials_var TAO_SSLIOP_Credentials::_var_type

| Reimplemented from CORBA::LocalObject.

## Constructor & Destructor Documentation

TAO_SSLIOP_Credentials::TAO_SSLIOP_Credentials | ( | X509 * | cert,
|  | EVP_PKEY * | evp
| ) |

| Constructor.

TAO_SSLIOP_Credentials::~TAO_SSLIOP_Credentials | ( | void |  | ) | `[protected]`

| Destructor. Destructor is protected to enforce proper reference counting. Specifically, this reference counted object should only be deallocated by the reference counting mechanism.

## Member Function Documentation

TAO_SSLIOP_Credentials_ptr TAO_SSLIOP_Credentials::_duplicate | ( | TAO_SSLIOP_Credentials_ptr | obj | ) | `[static]`

TAO_SSLIOP_Credentials_ptr TAO_SSLIOP_Credentials::_narrow | ( | CORBA::Object_ptr obj | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | `[static]`

| Reimplemented from CORBA::LocalObject. Reimplemented in TAO_SSLIOP_ReceivedCredentials, and TAO_SSLIOP_TargetCredentials.

TAO_SSLIOP_Credentials_ptr TAO_SSLIOP_Credentials::_nil | ( | void |  | ) | `[inline, static]`

| Reimplemented from CORBA::LocalObject. Reimplemented in TAO_SSLIOP_ReceivedCredentials, and TAO_SSLIOP_TargetCredentials.

void TAO_SSLIOP_Credentials::accepting_options_required | ( | Security::AssociationOptions accepting_options_required | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

Security::AssociationOptions TAO_SSLIOP_Credentials::accepting_options_required | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

void TAO_SSLIOP_Credentials::accepting_options_supported | ( | Security::AssociationOptions accepting_options_supported | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

Security::AssociationOptions TAO_SSLIOP_Credentials::accepting_options_supported | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

Security::AuthenticationStatus TAO_SSLIOP_Credentials::authentication_state | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

SecurityLevel2::Credentials_ptr TAO_SSLIOP_Credentials::copy | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Return a duplicate (specifically a deep copy) of this credential object. Reimplemented in TAO_SSLIOP_ReceivedCredentials, and TAO_SSLIOP_TargetCredentials.

Security::InvocationCredentialsType TAO_SSLIOP_Credentials::credentials_type | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Return the invocation credentials type this object is. If this Credentials object was created by the PrincipalAuthenticator then the "own" credentials type (i.e. Security::SecOwnCredentials) is returned. Specifically, the credentials represented by this Credentials object are our own, not the peer's credentials. If this Credentials object corresponds to the credentials received from the peer, then the "received" credentials type (i.e. Security::SecReceivedCredentials) is returned. If this Credentials object corresponds to the target object's credentials then the "target" credentials type (i.e. Security::SecTargetCredentials) is returned. Reimplemented in TAO_SSLIOP_ReceivedCredentials, and TAO_SSLIOP_TargetCredentials.

void TAO_SSLIOP_Credentials::destroy | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

ACE_INLINE EVP_PKEY * TAO_SSLIOP_Credentials::evp | ( | void |  | ) |

| Return a pointer to the underlying private key. Returns: Non-zero value if private key is used. Note: Caller owns the returned object. Use a TAO_SSLIOP_EVP_PKEY_var.

virtual Security::AttributeList* TAO_SSLIOP_Credentials::get_attributes | ( | const Security::AttributeTypeList &attributes | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

CORBA::Boolean TAO_SSLIOP_Credentials::get_security_feature | ( | Security::CommunicationDirection | direction,
|  | Security::SecurityFeature feature | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)`[virtual]`

CORBA::ULong TAO_SSLIOP_Credentials::hash | ( | void |  | ) | const

void TAO_SSLIOP_Credentials::invocation_options_required | ( | Security::AssociationOptions invocation_options_required | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

Security::AssociationOptions TAO_SSLIOP_Credentials::invocation_options_required | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

void TAO_SSLIOP_Credentials::invocation_options_supported | ( | Security::AssociationOptions invocation_options_supported | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

Security::AssociationOptions TAO_SSLIOP_Credentials::invocation_options_supported | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

CORBA::Boolean TAO_SSLIOP_Credentials::is_valid | ( | Security::UtcT_out expiry_time | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Verify that this credential is still valid.

char * TAO_SSLIOP_Credentials::mechanism | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

CORBA::Boolean TAO_SSLIOP_Credentials::operator== | ( | const TAO_SSLIOP_Credentials & | rhs | ) |

virtual CORBA::Boolean TAO_SSLIOP_Credentials::refresh | ( | const CORBA::Any &refresh_data | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

CORBA::Boolean TAO_SSLIOP_Credentials::set_attributes | ( | const Security::AttributeList & | requested_attributes,
|  | Security::AttributeList_out actual_attributes | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)`[virtual]`

ACE_INLINE X509 * TAO_SSLIOP_Credentials::x509 | ( | void |  | ) |

| Return a pointer to the underlying X.509 certificate. Note: Caller owns the returned object. Use a TAO_SSLIOP_X509_var.

## Member Data Documentation

int TAO_SSLIOP_Credentials::_tao_class_id = 0`[static]`

| Reimplemented in TAO_SSLIOP_ReceivedCredentials, and TAO_SSLIOP_TargetCredentials.

Security::AssociationOptions TAO_SSLIOP_Credentials::accepting_options_required_`[protected]`

| This attribute corresponds to the SSLIOP::target_requires field in the security association options in the SSLIOP tagged component that is embedded in IORs created by SSLIOP-enabled server side ORBs.

Security::AssociationOptions TAO_SSLIOP_Credentials::accepting_options_supported_`[protected]`

| This attribute corresponds to the SSLIOP::target_supports field in the security association options in the SSLIOP tagged component that is embedded in IORs created by SSLIOP-enabled server side ORBs.

TAO_SSLIOP_EVP_PKEY_var TAO_SSLIOP_Credentials::evp_`[protected]`

| Reference to the private key associated with the X.509 certificate.

Security::AssociationOptions TAO_SSLIOP_Credentials::invocation_options_required_`[protected]`

| Security association options required by this Credentials object when invoking operations on the target object.

Security::AssociationOptions TAO_SSLIOP_Credentials::invocation_options_supported_`[protected]`

| Security association options supported by this Credentials object when invoking operations on the target object.

TAO_SSLIOP_X509_var TAO_SSLIOP_Credentials::x509_`[protected]`

| Reference to the X.509 certificate associated with this SSLIOP Credentials object.

The documentation for this class was generated from the following files:

- SSLIOP_Credentials.h
- SSLIOP_Credentials.cpp
- SSLIOP_Credentials.inl